<?

function Head() {
global $code,$Addres;
$eof = false;
$i = 0;
  while(!$eof) {
    switch($i) {
      default     : $code[$i] = pack('c*',0x00);                break;
      case 0x00   : $code[$i] = pack('V*',0x5A4D);      $i+=3;  break; // MZ 
      case 0x18   : $code[$i] = pack('c*',0x40);                break; //   DOS 
      case 0x1C   : $code[$i] = pack('V*',0x00);        $i+=3;  break; // 4   
      case 0x20   : $code[$i] = pack('c*',0x00);                break; //   
      case 0x3C   : $code[$i] = pack('V*',0x100);       $i+=3;  break; //  PE 
      case 0x40   : $code[$i] = pack('V*',0x0EBa1F0E);  $i+=3;  break; // DOS 
      case 0x44   : $code[$i] = pack('V*',0xCD09B400);  $i+=3;  break; // DOS 
      case 0x48   : $code[$i] = pack('V*',0x4C01B821);  $i+=3;  break; // DOS 
      case 0x4C   : $code[$i] = pack('v*',0x21CD);      $i+=1;  break; // DOS 
      case 0x4E   : $code[$i] = 'This program cannot be run in DOS mode.'; $i+=38; break;
      case 0x75   : $code[$i] = pack('V*',0x240A0D);    $i+=3;  break; // DOS 
      case 0x80   : $eof      = true;                           break;
    }
    $i++;
  }
  $Addres = $i-1;
}

function PE_header($offset = 0x100){
global $code, $Addres;
$eof = false;
$i = $Addres;
  while(!$eof) {
    switch($i-$offset) {
      default     : $code[$i] = pack('c*',0x00);                break;
      case 0x00   : $code[$i] = pack('V*',0x4550);      $i+=3;  break;  // PE 
      case 0x04   : $code[$i] = pack('v*',0x014C);      $i+=1;  break;  //     ,14Ch  "i386"
      case 0x06   : $code[$i] = pack('c*',0x01);                break;  //       Object Table
      case 0x08   : $code[$i] = pack('V*',0x00);        $i+=3;  break;  //     /   
      case 0x0C   : $code[$i] = pack('V*',0x00);        $i+=3;  break;  // ,    COFF   
      case 0x10   : $code[$i] = pack('V*',0x00);        $i+=3;  break;  //    COFF 
      case 0x14   : $code[$i] = pack('v*',0xE0);        $i+=1;  break;  //   PE ,    Magic,  ,    PE   NT Header Size + 18h (  Magic)
      case 0x16   : $code[$i] = pack('v*',0x010E);      $i+=1;  break;  /* ,    
                                                                          * 0000h   
                                                                          * 0001h -        
                                                                          * 0002h -     
                                                                          * 0200h -  , ..   ,   Image Base
                                                                          * 2000h -   */
      case 0x18   : $code[$i] = pack('v*',0x010B);      $i+=1;  break;  //     ,   010Bh
      case 0x28   : $code[$i] = pack('v*',0x1170);      $i+=1;  break;  // T 
      case 0x34   : $code[$i] = pack('V*',0x400000);    $i+=3;  break;  //      (  )
      case 0x38   : $code[$i] = pack('V*',0x1000);      $i+=3;  break;  //   ,    2  512  256 
      case 0x3C   : $code[$i] = pack('V*',0x200);       $i+=3;  break;  //     ,   ,     0    .    2    512  64 .
      case 0x40   : $code[$i] = pack('v*',0x04);        $i+=1;  break;  //    ,    .
      case 0x42   : $code[$i] = pack('v*',0x00);        $i+=1;  break;  //    
      case 0x44   : $code[$i] = pack('v*',0x00);        $i+=1;  break;  //   ,     
      case 0x46   : $code[$i] = pack('v*',0x00);        $i+=1;  break;  // ,  
      case 0x48   : $code[$i] = pack('v*',0x04);        $i+=1;  break;  //    
      case 0x4A   : $code[$i] = pack('v*',0x00);        $i+=1;  break;  // ,  
      case 0x4C   : $code[$i] = pack('v*',0x00);        $i+=1;  break;  // 
      case 0x50   : $code[$i] = pack('V*',0x2000);      $i+=3;  break;  //       ,   ,  Object align
      case 0x54   : $code[$i] = pack('V*',0x400);       $i+=3;  break;  // +    : DOS Stub + PE Header + Object Table
      case 0x58   : $code[$i] = pack('V*',0x00);        $i+=3;  break;  //    ,      .
      case 0x5C   : $code[$i] = pack('c*',0x02);                break;  // ,     (GUI-0002h, -0003h, )
      case 0x74   : $code[$i] = pack('c*',0x10);                break;  //    VA/Size,   ,    10h
      case 0x80   : $code[$i] = pack('V*',0x10A0);      $i+=3;  break;  // ** RVA   
      case 0x84   : $code[$i] = pack('V*',0xC8);        $i+=3;  break;  //   
                                                                       /* 188 - 1E8  //      */
      case 0x88   : $eof      = true;                           break;
    }
    $i++;
  }
  $Addres = $i-1;
}

function TableObject($offset = 0x100){
global $code, $Addres;
$eof = false;
$i = $Addres;
  while(!$eof) {
    switch($i-$offset) {
      default     : $code[$i] = pack('c*',0x00);                break;
      case 0xF0   : $code[$i] = '.code';                $i+=4;  break;  //   8 
      case 0x100  : $code[$i] = pack('V*',0x200);       $i+=3;  break;  //   ,       .  Virtual Size  Physical Size,    ,      (Physical Size = 0)
      case 0x104  : $code[$i] = pack('V*',0x1000);      $i+=3;  break;  //    ,     Image Base
      case 0x108  : $code[$i] = pack('V*',0x200);       $i+=3;  break;  //   (  )  ,      Virtual Size
      case 0x10C  : $code[$i] = pack('V*',0x400);       $i+=3;  break;  //     EXE 
      case 0x11C  : $code[$i] = pack('V*',0xE0000020);  $i+=3;  break;  /*     :
                                                                           * 00000004h -     16  
                                                                           * 00000020h -  
                                                                           * 00000040h -   
                                                                           * 00000080h -   
                                                                           * 00000200h -      
                                                                           * 00000400h -  
                                                                           * 00000800h -      
                                                                           * 00001000h -  
                                                                           * 00500000h -   ,    
                                                                           * 02000000h -     
                                                                           * 04000000h -  
                                                                           * 08000000h -    
                                                                           * 10000000h - 
                                                                           * 20000000h - 
                                                                           * 40000000h -  
                                                                           * 80000000h -   */
      case 0x120  : $eof      = true;                           break;
    }
    $i++;
  }
  $Addres = $i-1;
}

function Code($offset = 0x400){
global $code, $Addres;
$eof = false;
$i = $Addres;
  while(!$eof) {
    switch($i-$offset) {
      default     : $code[$i] = pack('c*',0x00);                break;
      case 0x00   : $code[$i] = 'Caption';              $i+=6;  break;
      case 0x10   : $code[$i] = 'Hello Word!';          $i+=10; break;

      case 0x20   : $code[$i] = pack('v*',0x00);        $i+=1;  break;
      case 0x22   : $code[$i] = 'MessageBoxA';          $i+=10; break;
      case 0x30   : $code[$i] = pack('v*',0x00);        $i+=1;  break;
      case 0x32   : $code[$i] = 'ExitProcess';          $i+=10; break;

      case 0x40   : $code[$i] = 'USER32.dll';           $i+=9;  break;
      case 0x50   : $code[$i] = 'KERNEL32.dll';         $i+=11; break;

      case 0x60   : $code[$i] = pack('V*',0x1030,0x00); $i+=7;  break; // + [!] IAT --   ExitProcess
      case 0x70   : $code[$i] = pack('V*',0x1020,0x00); $i+=7;  break; // 2 IAT   MessageBoxA

      case 0xA0   : $code[$i] = pack('V*',                             // **    
                                       0x1060,                         // --   
                                       0x00,                           //   
                                       0x00,
                                       0x1050,                         //      KERNEL32.dll
                                       0x1060);         $i+=19; break; // [!]  IAT
      case 0xB4   : $code[$i] = pack('V*',
                                       0x1070,                         // --  2  
                                       0x00,                           //   
                                       0x00,
                                       0x1040,                         //      USER32.dll
                                       0x1070);         $i+=19; break; // [!]  2 IAT
      case 0x170  : $code[$i] = pack('c*',
                                       0x6A,0x00,                      // Push 0
                                       0x68,0x00,0x10,0x40,0x00,       // Push offset _title   (    40 10 10 - Caption)
                                       0x68,0x10,0x10,0x40,0x00,       // Push offset _message (    40 10 20 - Hello Word!)
                                       0x6A,0x00,                      // Push 0
                                       0xFF,0x15,0x70,0x10,0x40,0x00,  // call MessageBoxA     (   2 IAT  40 00 00)
                                       0x6A,0x00,                      // Push 0
                                       0xFF,0x15,0x60,0x10,0x40,0x00);
                                                        $i+=27; break; // Call ExitProcess,0   (   1 IAT  40 00 08)
      case 0x300  : $eof      = true;                           break;
    }
    $i++;
  }
  $Addres = $i-1;
}

?>